﻿--Create a namespace
DM = {};
DM.currentherb = nil;

--Create Draenor herb list
DM.herbs = {
  { ["name"] = "Frostweed",
    ["id"] = 109124,
    ["button"] = nil
  },
  { ["name"] = "Fireweed",
    ["id"] = 109125,
    ["button"] = nil
  },
  { ["name"] = "Gorgrond Flytrap",
    ["id"] = 109126,
    ["button"] = nil
  },
  { ["name"] = "Starflower",
    ["id"] = 109127,
    ["button"] = nil
  },
  { ["name"] = "Nagrand Arrowbloom",
    ["id"] = 109128,
    ["button"] = nil
  },
  { ["name"] = "Talador Orchid",
    ["id"] = 109129,
    ["button"] = nil
  }
}

-- Window size
DM.width = 250;
DM.height = 100;
DM.topheight = 25; -- of title bar

--Create backdrop and edges
local background = "Interface\\DialogFrame\\UI-DialogBox-Background"
local edge = "Interface\\Tooltips\\UI-Tooltip-Border"
--local edge = "Interface\\DialogFrame\\UI-DialogBox-Border"
local backdrop = {
  bgFile = background,
  edgeFile = edge,
  tile = true, tileSize = 10, edgeSize = 15,
  insets = { left = 2, right = 2, top = 2, bottom = 2 }
  -- NOTE:  Insets controls how far into the frame the background will be drawn
  --        Set this to a larger value for a thicker edge
}

--Create frame to hold buttons, etc.
DM.frame = CreateFrame("Frame");
DM.frame:SetFrameStrata("HIGH");
DM.frame:SetParent(UIParent);
DM.frame:SetBackdrop(backdrop);
DM.frame:SetMovable(true)
DM.frame:EnableMouse(true)
DM.frame:RegisterForDrag("LeftButton")
DM.frame:SetWidth(DM.width);
DM.frame:SetHeight(DM.height);
DM.frame:SetPoint("CENTER",UIParent,"CENTER",0,0);
DM.frame:Hide();

--Create title frame
DM.frame.title = CreateFrame("Frame","DraenorMiller_Title",DM.frame);
DM.frame.title:SetBackdrop(backdrop);
DM.frame.title:SetWidth(DM.width-DM.topheight+4);
DM.frame.title:SetHeight(DM.topheight);
DM.frame.title:SetMovable(true)
DM.frame.title:EnableMouse(true)
DM.frame.title:RegisterForDrag("LeftButton")
-- Set string
DM.frame.title.str = DM.frame.title:CreateFontString(nil, "ARTWORK", "GameFontNormal");
DM.frame.title.str:SetPoint("LEFT", DM.frame.title, 10, 0);
DM.frame.title.str:SetText("Draenor Miller");
DM.frame.title:SetPoint("TOPLEFT",DM.frame,"TOPLEFT",0,0);

--Create exit button
DM.frame.exitbutton = CreateFrame("Button","DraenorMiller_ExitButton",DM.frame,"UIPanelCloseButton");
DM.frame.exitbutton:SetFrameStrata("HIGH");
DM.frame.exitbutton:SetWidth(DM.topheight+4);
DM.frame.exitbutton:SetHeight(DM.topheight+4);
DM.frame.exitbutton:SetPoint("TOPRIGHT",DM.frame,"TOPRIGHT",2,2);

-- Create border
DM.frame.exitbutton.border = CreateFrame("Frame","DraenorMiller_ExitButtonBorder",DM.frame);
DM.frame.exitbutton.border:SetFrameStrata("MEDIUM");
DM.frame.exitbutton.border:SetBackdrop(backdrop);
DM.frame.exitbutton.border:SetWidth(DM.topheight);
DM.frame.exitbutton.border:SetHeight(DM.topheight);
DM.frame.exitbutton.border:SetPoint("TOPRIGHT",DM.frame,"TOPRIGHT",0,0);

--Create clickable button
DM.frame.button = CreateFrame("Button","DraenorMiller_Button",DM.frame,"SecureActionButtonTemplate,UIPanelButtonTemplate");
DM.frame.button:RegisterForClicks("AnyDown");
DM.frame.button:SetWidth(0.8*DM.width);
DM.frame.button:SetHeight(DM.topheight);
DM.frame.button:SetPoint("BOTTOM",DM.frame,"BOTTOM",0,0);

SLASH_DRAENORMILLER1 = '/dm';

SlashCmdList["DRAENORMILLER"] = function(msg)
  
  -- arg1 is the first word of the argument (before whitespace)
  -- remainder is the remaining of the argument
  local arg1, remainder = msg:match("^(%S*)%s*(.-)$");
  
  -- Check if user has inscription
  if IsSpellKnown(51005) then
    
    -- If only requesting current herb info
    if arg1 == "current" then
      
      if not DM.haveherbs then
        DM.UpdateFrames();
      else
        print("Draenor Miller - ".. DM.currentherb.name .. " is the current milling default.");
      end
      
    -- If wanting to display screen  
    else
      
      --Show main frame if we have herbs
      if not DM.haveherbs then
        DM.SetDefaultHerb(); -- check to see if we've acquired herbs
      end
      if DM.haveherbs then
        DM.frame:Show();
      else
        print("Draenor Miller - Need 5 or more herbs to mill.");
      end
      
    end
    
  else
    
    local prace = UnitRace("player");
    print("Draenor Miller - Silly "..prace..", you don't know how to mill.");
    
  end
  
end

function DM.DefineHerbButtons()
  for i = 1, #DM.herbs do
    DM.herbs[i].button = CreateFrame("Button", DM.herbs[i].name, DM.frame, "SecureActionButtonTemplate,ActionButtonTemplate");
    local adj = 3;
    local sz = DM.width/#DM.herbs-adj;
    DM.herbs[i].button:SetWidth(sz);
    DM.herbs[i].button:SetHeight(sz);
    DM.herbs[i].button:RegisterForClicks("AnyDown");
    
    -- Herb button positions
    DM.herbs[i].button:SetPoint("CENTER",DM.frame, "CENTER", -0.5*DM.width + 0.5*sz + sz*(i-1) + 0.5*adj*#DM.herbs, 0);
    
    -- Herb button background pictures    
    DM.herbs[i].button.icon = DM.herbs[i].button:CreateTexture(nil, "BACKGROUND");
    DM.herbs[i].button.icon:SetAllPoints(true);
    DM.herbs[i].button.icon:SetTexture(GetItemIcon(DM.herbs[i].id));
    
    -- Herb button number
    DM.herbs[i].button.str = DM.herbs[i].button:CreateFontString(nil,"ARTWORK","NumberFontNormal");
    DM.herbs[i].button.str:SetPoint("BOTTOMRIGHT", DM.herbs[i].button, 0, 0);
    DM.herbs[i].button.str:SetJustifyH("RIGHT");
    DM.UpdateHerbNumber(DM.herbs[i]);
    
    -- Define click function
    DM.herbs[i].button:SetScript("OnClick",function(self)
      DM.SetCurrentHerb(DM.herbs[i]);
    end)
  end
end

function DM.SetCurrentHerb(herb)
  if GetItemCount(herb.id)>=5 then
    DM.currentherb = herb;
    print("Draenor Miller - "..DM.currentherb.name .. " set as milling default.");
  elseif GetItemCount(DM.currentherb.id)>=5 then
    print("Draenor Miller - Need 5 or more "..herb.name.." to mill.");
  else
    DM.UpdateButtonAlpha(herb, 0.25);
    DM.SetDefaultHerb();
  end
  DM.UpdateButtonMacro();
  DM.UpdateButtonText();
end

function DM.SetDefaultHerb()
  DM.haveherbs = false;
  for i = 1, #DM.herbs do
    if GetItemCount(DM.herbs[i].id)>=5 then
      if not DM.haveherbs then
        DM.currentherb = DM.herbs[i];
        DM.haveherbs = true;
      end
      DM.UpdateButtonAlpha(DM.herbs[i],1.0);
    else
      DM.UpdateButtonAlpha(DM.herbs[i],0.25);
    end
  end
  
  if DM.haveherbs then
    DM.UpdateButtonMacro();
    DM.UpdateButtonText();
    print("Draenor Miller - "..DM.currentherb.name .. " set as milling default.");
  end
  
end

function DM.UpdateButtonText()
  DM.frame.button:SetText("Mill "..DM.currentherb.name.."!");
end

function DM.UpdateButtonMacro()
  DM.frame.button:SetAttribute("macrotext","/cast Milling\n/use "..DM.currentherb.name);
end

function DM.UpdateButtonAlpha(herb,alpha)
  herb.button.icon:SetAlpha(alpha);
  herb.button.str:SetAlpha(alpha);
end

function DM.UpdateHerbNumber(herb)
  herb.button.str:SetText(GetItemCount(herb.id));
end

function DM.UpdateFrames()
  local gcount = 0;
  for i = 1, #DM.herbs do
    DM.UpdateHerbNumber(DM.herbs[i]);
    local count = GetItemCount(DM.herbs[i].id);
    if count>=5 then
      gcount = gcount + 1;
      DM.UpdateButtonAlpha(DM.herbs[i],1.0);
    else
      DM.UpdateButtonAlpha(DM.herbs[i],0.25);
    end
  end
  
  if gcount == 0 then
    DM.haveherbs = false;
    print("Draenor Miller - Not enough herbs for milling.");
    DM.frame.button:SetAttribute("macrotext","");
    DM.frame:Hide();
  elseif DM.currentherb == nil then
    DM.SetDefaultHerb();
  elseif GetItemCount(DM.currentherb.id)<5 then
    print("Draenor Miller - Need 5 or more "..DM.currentherb.name.." to mill.");
    DM.SetDefaultHerb();
  elseif GetItemCount(DM.currentherb.id)>=5 and not DM.haveherbs then
    DM.haveherbs = true;
    print("Draenor Miller - "..DM.currentherb.name .. " set as milling default.");
    DM.UpdateButtonMacro();
    DM.UpdateButtonText();
  end
end

-- This will run on load
-- Herb flag default
DM.haveherbs = false;
  
--Define herb buttons
DM.DefineHerbButtons();
  
--Set mill button defaults
DM.frame.button:SetAttribute("type","macro");
DM.frame.button:SetScript("OnUpdate",DM.UpdateFrames);
DM.frame.button:SetScript("PreClick",DM.UpdateFrames);
  
--Set movable window scripts
DM.frame.title:SetScript("OnDragStart", function(self, button)
  DM.frame:StartMoving()
end)
DM.frame.title:SetScript("OnDragStop", function(self, button)
  DM.frame:StopMovingOrSizing()
end)
DM.frame.title:SetScript("OnHide", function(self)
  DM.frame:StopMovingOrSizing()
end)